# coding: utf-8

from __future__ import absolute_import

from datetime import date, datetime
from typing import Dict, List

from cic_eth.server import util
from cic_eth.server.models.base_model_ import Model


class Transaction(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(self, block_number: int = None, date_checked: str = None, date_created: str = None, date_updated: str = None, destination_token: str = None, destination_token_decimals: int = None, destination_token_symbol: str = None, from_value: int = None, hash: str = None, nonce: int = None, recipient: str = None, sender: str = None, signed_tx: str = None, source_token: str = None, source_token_decimals: int = None, source_token_symbol: str = None, status: str = None, status_code: int = None, timestamp: int = None, to_value: int = None, tx_hash: str = None, tx_index: int = None):
        """Transaction - a model defined in Swagger

        :param block_number: The block_number of this Transaction.  
        :type block_number: int
        :param date_checked: The date_checked of this Transaction.  
        :type date_checked: str
        :param date_created: The date_created of this Transaction.  
        :type date_created: str
        :param date_updated: The date_updated of this Transaction.  
        :type date_updated: str
        :param destination_token: The destination_token of this Transaction.  
        :type destination_token: str
        :param destination_token_decimals: The destination_token_decimals of this Transaction.  
        :type destination_token_decimals: int
        :param destination_token_symbol: The destination_token_symbol of this Transaction.  
        :type destination_token_symbol: str
        :param from_value: The from_value of this Transaction.  
        :type from_value: int
        :param hash: The hash of this Transaction.  
        :type hash: str
        :param nonce: The nonce of this Transaction.  
        :type nonce: int
        :param recipient: The recipient of this Transaction.  
        :type recipient: str
        :param sender: The sender of this Transaction.  
        :type sender: str
        :param signed_tx: The signed_tx of this Transaction.  
        :type signed_tx: str
        :param source_token: The source_token of this Transaction.  
        :type source_token: str
        :param source_token_decimals: The source_token_decimals of this Transaction.  
        :type source_token_decimals: int
        :param source_token_symbol: The source_token_symbol of this Transaction.  
        :type source_token_symbol: str
        :param status: The status of this Transaction.  
        :type status: str
        :param status_code: The status_code of this Transaction.  
        :type status_code: int
        :param timestamp: The timestamp of this Transaction.  
        :type timestamp: int
        :param to_value: The to_value of this Transaction.  
        :type to_value: int
        :param tx_hash: The tx_hash of this Transaction.  
        :type tx_hash: str
        :param tx_index: The tx_index of this Transaction.  
        :type tx_index: int
        """
        self.swagger_types = {
            'block_number': int,
            'date_checked': str,
            'date_created': str,
            'date_updated': str,
            'destination_token': str,
            'destination_token_decimals': int,
            'destination_token_symbol': str,
            'from_value': int,
            'hash': str,
            'nonce': int,
            'recipient': str,
            'sender': str,
            'signed_tx': str,
            'source_token': str,
            'source_token_decimals': int,
            'source_token_symbol': str,
            'status': str,
            'status_code': int,
            'timestamp': int,
            'to_value': int,
            'tx_hash': str,
            'tx_index': int
        }

        self.attribute_map = {
            'block_number': 'block_number',
            'date_checked': 'date_checked',
            'date_created': 'date_created',
            'date_updated': 'date_updated',
            'destination_token': 'destination_token',
            'destination_token_decimals': 'destination_token_decimals',
            'destination_token_symbol': 'destination_token_symbol',
            'from_value': 'from_value',
            'hash': 'hash',
            'nonce': 'nonce',
            'recipient': 'recipient',
            'sender': 'sender',
            'signed_tx': 'signed_tx',
            'source_token': 'source_token',
            'source_token_decimals': 'source_token_decimals',
            'source_token_symbol': 'source_token_symbol',
            'status': 'status',
            'status_code': 'status_code',
            'timestamp': 'timestamp',
            'to_value': 'to_value',
            'tx_hash': 'tx_hash',
            'tx_index': 'tx_index'
        }
        self._block_number = block_number
        self._date_checked = date_checked
        self._date_created = date_created
        self._date_updated = date_updated
        self._destination_token = destination_token
        self._destination_token_decimals = destination_token_decimals
        self._destination_token_symbol = destination_token_symbol
        self._from_value = from_value
        self._hash = hash
        self._nonce = nonce
        self._recipient = recipient
        self._sender = sender
        self._signed_tx = signed_tx
        self._source_token = source_token
        self._source_token_decimals = source_token_decimals
        self._source_token_symbol = source_token_symbol
        self._status = status
        self._status_code = status_code
        self._timestamp = timestamp
        self._to_value = to_value
        self._tx_hash = tx_hash
        self._tx_index = tx_index

    @classmethod
    def from_dict(cls, dikt) -> 'Transaction':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Transaction of this Transaction.  
        :rtype: Transaction
        """
        return util.deserialize_model(dikt, cls)

    @property
    def block_number(self) -> int:
        """Gets the block_number of this Transaction.


        :return: The block_number of this Transaction.
        :rtype: int
        """
        return self._block_number

    @block_number.setter
    def block_number(self, block_number: int):
        """Sets the block_number of this Transaction.


        :param block_number: The block_number of this Transaction.
        :type block_number: int
        """

        self._block_number = block_number

    @property
    def date_checked(self) -> str:
        """Gets the date_checked of this Transaction.


        :return: The date_checked of this Transaction.
        :rtype: str
        """
        return self._date_checked

    @date_checked.setter
    def date_checked(self, date_checked: str):
        """Sets the date_checked of this Transaction.


        :param date_checked: The date_checked of this Transaction.
        :type date_checked: str
        """

        self._date_checked = date_checked

    @property
    def date_created(self) -> str:
        """Gets the date_created of this Transaction.


        :return: The date_created of this Transaction.
        :rtype: str
        """
        return self._date_created

    @date_created.setter
    def date_created(self, date_created: str):
        """Sets the date_created of this Transaction.


        :param date_created: The date_created of this Transaction.
        :type date_created: str
        """

        self._date_created = date_created

    @property
    def date_updated(self) -> str:
        """Gets the date_updated of this Transaction.


        :return: The date_updated of this Transaction.
        :rtype: str
        """
        return self._date_updated

    @date_updated.setter
    def date_updated(self, date_updated: str):
        """Sets the date_updated of this Transaction.


        :param date_updated: The date_updated of this Transaction.
        :type date_updated: str
        """

        self._date_updated = date_updated

    @property
    def destination_token(self) -> str:
        """Gets the destination_token of this Transaction.


        :return: The destination_token of this Transaction.
        :rtype: str
        """
        return self._destination_token

    @destination_token.setter
    def destination_token(self, destination_token: str):
        """Sets the destination_token of this Transaction.


        :param destination_token: The destination_token of this Transaction.
        :type destination_token: str
        """

        self._destination_token = destination_token

    @property
    def destination_token_decimals(self) -> int:
        """Gets the destination_token_decimals of this Transaction.


        :return: The destination_token_decimals of this Transaction.
        :rtype: int
        """
        return self._destination_token_decimals

    @destination_token_decimals.setter
    def destination_token_decimals(self, destination_token_decimals: int):
        """Sets the destination_token_decimals of this Transaction.


        :param destination_token_decimals: The destination_token_decimals of this Transaction.
        :type destination_token_decimals: int
        """

        self._destination_token_decimals = destination_token_decimals

    @property
    def destination_token_symbol(self) -> str:
        """Gets the destination_token_symbol of this Transaction.


        :return: The destination_token_symbol of this Transaction.
        :rtype: str
        """
        return self._destination_token_symbol

    @destination_token_symbol.setter
    def destination_token_symbol(self, destination_token_symbol: str):
        """Sets the destination_token_symbol of this Transaction.


        :param destination_token_symbol: The destination_token_symbol of this Transaction.
        :type destination_token_symbol: str
        """

        self._destination_token_symbol = destination_token_symbol

    @property
    def from_value(self) -> int:
        """Gets the from_value of this Transaction.


        :return: The from_value of this Transaction.
        :rtype: int
        """
        return self._from_value

    @from_value.setter
    def from_value(self, from_value: int):
        """Sets the from_value of this Transaction.


        :param from_value: The from_value of this Transaction.
        :type from_value: int
        """

        self._from_value = from_value

    @property
    def hash(self) -> str:
        """Gets the hash of this Transaction.


        :return: The hash of this Transaction.
        :rtype: str
        """
        return self._hash

    @hash.setter
    def hash(self, hash: str):
        """Sets the hash of this Transaction.


        :param hash: The hash of this Transaction.
        :type hash: str
        """

        self._hash = hash

    @property
    def nonce(self) -> int:
        """Gets the nonce of this Transaction.


        :return: The nonce of this Transaction.
        :rtype: int
        """
        return self._nonce

    @nonce.setter
    def nonce(self, nonce: int):
        """Sets the nonce of this Transaction.


        :param nonce: The nonce of this Transaction.
        :type nonce: int
        """

        self._nonce = nonce

    @property
    def recipient(self) -> str:
        """Gets the recipient of this Transaction.


        :return: The recipient of this Transaction.
        :rtype: str
        """
        return self._recipient

    @recipient.setter
    def recipient(self, recipient: str):
        """Sets the recipient of this Transaction.


        :param recipient: The recipient of this Transaction.
        :type recipient: str
        """

        self._recipient = recipient

    @property
    def sender(self) -> str:
        """Gets the sender of this Transaction.


        :return: The sender of this Transaction.
        :rtype: str
        """
        return self._sender

    @sender.setter
    def sender(self, sender: str):
        """Sets the sender of this Transaction.


        :param sender: The sender of this Transaction.
        :type sender: str
        """

        self._sender = sender

    @property
    def signed_tx(self) -> str:
        """Gets the signed_tx of this Transaction.


        :return: The signed_tx of this Transaction.
        :rtype: str
        """
        return self._signed_tx

    @signed_tx.setter
    def signed_tx(self, signed_tx: str):
        """Sets the signed_tx of this Transaction.


        :param signed_tx: The signed_tx of this Transaction.
        :type signed_tx: str
        """

        self._signed_tx = signed_tx

    @property
    def source_token(self) -> str:
        """Gets the source_token of this Transaction.


        :return: The source_token of this Transaction.
        :rtype: str
        """
        return self._source_token

    @source_token.setter
    def source_token(self, source_token: str):
        """Sets the source_token of this Transaction.


        :param source_token: The source_token of this Transaction.
        :type source_token: str
        """

        self._source_token = source_token

    @property
    def source_token_decimals(self) -> int:
        """Gets the source_token_decimals of this Transaction.


        :return: The source_token_decimals of this Transaction.
        :rtype: int
        """
        return self._source_token_decimals

    @source_token_decimals.setter
    def source_token_decimals(self, source_token_decimals: int):
        """Sets the source_token_decimals of this Transaction.


        :param source_token_decimals: The source_token_decimals of this Transaction.
        :type source_token_decimals: int
        """

        self._source_token_decimals = source_token_decimals

    @property
    def source_token_symbol(self) -> str:
        """Gets the source_token_symbol of this Transaction.


        :return: The source_token_symbol of this Transaction.
        :rtype: str
        """
        return self._source_token_symbol

    @source_token_symbol.setter
    def source_token_symbol(self, source_token_symbol: str):
        """Sets the source_token_symbol of this Transaction.


        :param source_token_symbol: The source_token_symbol of this Transaction.
        :type source_token_symbol: str
        """

        self._source_token_symbol = source_token_symbol

    @property
    def status(self) -> str:
        """Gets the status of this Transaction.


        :return: The status of this Transaction.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status: str):
        """Sets the status of this Transaction.


        :param status: The status of this Transaction.
        :type status: str
        """

        self._status = status

    @property
    def status_code(self) -> int:
        """Gets the status_code of this Transaction.


        :return: The status_code of this Transaction.
        :rtype: int
        """
        return self._status_code

    @status_code.setter
    def status_code(self, status_code: int):
        """Sets the status_code of this Transaction.


        :param status_code: The status_code of this Transaction.
        :type status_code: int
        """

        self._status_code = status_code

    @property
    def timestamp(self) -> int:
        """Gets the timestamp of this Transaction.


        :return: The timestamp of this Transaction.
        :rtype: int
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp: int):
        """Sets the timestamp of this Transaction.


        :param timestamp: The timestamp of this Transaction.
        :type timestamp: int
        """

        self._timestamp = timestamp

    @property
    def to_value(self) -> int:
        """Gets the to_value of this Transaction.


        :return: The to_value of this Transaction.
        :rtype: int
        """
        return self._to_value

    @to_value.setter
    def to_value(self, to_value: int):
        """Sets the to_value of this Transaction.


        :param to_value: The to_value of this Transaction.
        :type to_value: int
        """

        self._to_value = to_value

    @property
    def tx_hash(self) -> str:
        """Gets the tx_hash of this Transaction.


        :return: The tx_hash of this Transaction.
        :rtype: str
        """
        return self._tx_hash

    @tx_hash.setter
    def tx_hash(self, tx_hash: str):
        """Sets the tx_hash of this Transaction.


        :param tx_hash: The tx_hash of this Transaction.
        :type tx_hash: str
        """

        self._tx_hash = tx_hash

    @property
    def tx_index(self) -> int:
        """Gets the tx_index of this Transaction.


        :return: The tx_index of this Transaction.
        :rtype: int
        """
        return self._tx_index

    @tx_index.setter
    def tx_index(self, tx_index: int):
        """Sets the tx_index of this Transaction.


        :param tx_index: The tx_index of this Transaction.
        :type tx_index: int
        """

        self._tx_index = tx_index
